#!/bin/sh

#
# First check if gettext is installed
#

if [ -x /usr/bin/msgfmt.exe ]
then

  #
  # Create a Dorgem.pot
  #

  rm -f Dorgem.pot
  xgettext -C -k_ -n -o Dorgem.pot ../Src/*.cpp

  #
  # There should not be a .mo in this directory anyway
  #

  rm -f *.mo

  #
  #
  #

  for lang in `ls *.po | grep -v Dorgem\.pot | sed -e s/\.po//g`
  do
    echo -n "Updating $lang.po"
    cp $lang.po $lang-old.po
    msgmerge -o $lang.po --no-wrap $lang-old.po Dorgem.pot
    rm $lang-old.po
  done

  #
  # Clean up the mess
  #

  rm -f Dorgem.pot

else
  echo "gettext not installed"
fi

echo
echo
echo "---- DONE ----"
sleep 5
