#!/bin/sh

if [ -x /usr/bin/msgfmt.exe ]
then

  #
  # There should not be a .mo in this directory anyway
  #

  rm -f *.mo

  #
  # First make sure the directory structure is available
  #

  echo "Building .mo files:"
  echo

  if [ ! -d ../Win32/Debug ]
  then
    mkdir ../Win32/Debug
  fi

  if [ ! -d ../Win32/Debug/locale ]
  then
    mkdir ../Win32/Debug/locale
  fi

  #
  # Make the .mo files
  #

  for lang in `ls *.po | sed -e s/\.po//g`
  do

    echo "Building $lang"

    if [ ! -d ../Win32/Debug/locale/$lang ]
    then
      mkdir ../Win32/Debug/locale/$lang
    fi
    msgfmt --statistics -o ../Win32/Debug/locale/$lang/Dorgem.mo $lang.po

    echo

  done

else
  echo "gettext not installed"
fi

echo
echo "---- DONE ----"
sleep 5
