/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// CaptionBitmap.h : header file

#ifndef __CAPTIONBITMAP_H__
#define __CAPTIONBITMAP_H__

#include "CaptionEvent.h"

/////////////////////////////////////////////////////////////////////////////
//

class CCaptionBitmap : public CCaptionEvent
{
public:
  CCaptionBitmap();

  bool Overlay(wxImage&);

  wxFileName GetBitmap()          { return(m_fnImage);            };
  void SetBitmap(wxString s)      { m_fnImage = s;                };
  void SetRotate(int i)           { m_iRotate = i % 360;          };
  void SetScalePercentage(int i)  { m_iScalePercentage = i;       };
  void SetScaleXY(int x, int y)   { m_iScaleX = x; m_iScaleY = y; };

  bool Read(TiXmlElement*);
  bool Write(TiXmlElement*);

protected:
  wxFileName  m_fnImage;
  int         m_iRotate;
  int         m_iScalePercentage;
  int         m_iScaleX;
  int         m_iScaleY;

  void Rotate(wxImage&);
  void Scale(wxImage&);

};

#endif // __CAPTIONBITMAP_H__
