/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// CaptionEvent.cpp : implementation file

#include "Dorgem.h"
#include "CaptionEvent.h"

/////////////////////////////////////////////////////////////////////////////
// Initialize the members

CCaptionEvent::CCaptionEvent() : CDorgemEvent()
{
  m_iType = CAPTION_NONE;
  m_bAbsolute = false;
  m_iPosHor = POS_LEFT;
  m_iPosVer = POS_TOP;
}

/////////////////////////////////////////////////////////////////////////////
//

bool CCaptionEvent::Read(TiXmlElement* pElem)
{
  if (!CDorgemEvent::Read(pElem))
    return(false);

  m_iPosHor = wxGetApp().GetAttributeInt(pElem, g_strXmlPosHor, POS_LEFT);
  m_iPosVer = wxGetApp().GetAttributeInt(pElem, g_strXmlPosVer, POS_TOP);
  m_bAbsolute = wxGetApp().GetAttributeBool(pElem, g_strXmlAbsolute, false);
  return(true);
}

/////////////////////////////////////////////////////////////////////////////
//

bool CCaptionEvent::Write(TiXmlElement* pElem)
{
  if (!CDorgemEvent::Write(pElem))
    return(false);

  pElem->SetAttribute(g_strXmlAbsolute, m_bAbsolute);
  pElem->SetAttribute(g_strXmlPosHor, m_iPosHor);
  pElem->SetAttribute(g_strXmlPosVer, m_iPosVer);
  return(true);
}
