/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#ifndef __DORGEMDLG_H__
#define __DORGEMDLG_H__

// IDs for the controls and the menu commands
enum
{
  // Menu
  IDM_FILE_EXIT = wxID_EXIT,
  IDM_FILE_TEST = 1,
  IDM_HELP_LICENSE,
  IDM_HELP_CHECK_VERSION,
  IDM_HELP_ABOUT = wxID_ABOUT,

  ID_VIDEOWIN,
  ID_TIMER
};

class CVideoWindow;
class CWebServer;

// Class defenition
class CDorgemDlg: public wxFrame
{
public:
  CDorgemDlg(wxWindow* parent);
  ~CDorgemDlg();

  wxTextCtrl *m_logTextCtrl;

protected:
  CVideoWindow* m_vidCapWin;
  wxTimer       m_timer;

  // Declarations for the event table
  DECLARE_EVENT_TABLE();

  void OnFileExit(wxCommandEvent& event);
  void OnFileTest(wxCommandEvent& event);
  void OnHelpLicense(wxCommandEvent& event);
  void OnHelpCheckVersion(wxCommandEvent& event);
  void OnHelpAbout(wxCommandEvent& event);
  void OnTimer(wxTimerEvent& event);

  void StoreProfiles(bool bAlways);

  CWebServer* m_pServer;
};

#endif // __DORGEMDLG_H__
