/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// DorgemEvent.cpp : implementation file

#include "Dorgem.h"
#include "DorgemEvent.h"

/////////////////////////////////////////////////////////////////////////////
// Initialize the members

CDorgemEvent::CDorgemEvent()
{
  m_iType = 0;
  m_bEnabled = false;
  m_iOrder = 0;
}

/////////////////////////////////////////////////////////////////////////////
//

int CDorgemEvent::operator==(CDorgemEvent chk) const
{
  CDorgemEvent evtThis = *this;

  wxASSERT(evtThis.IsValid());
  wxASSERT(chk.IsValid());

  return(evtThis.m_strName == chk.m_strName);
}

/////////////////////////////////////////////////////////////////////////////
//

bool CDorgemEvent::IsValid()
{
  if (m_iType == 0)
    return(false);

  if (m_strName.IsEmpty())
    return(false);

  return(true);
}

/////////////////////////////////////////////////////////////////////////////
//

bool CDorgemEvent::Read(TiXmlElement* pElem)
{
  m_strName = wxGetApp().GetAttributeString(pElem, g_strXmlName);
  m_iOrder = wxGetApp().GetAttributeInt(pElem, g_strXmlOrder, 0);
  m_bEnabled = wxGetApp().GetAttributeBool(pElem, g_strXmlEnabled, false);
  return(IsValid());
}

/////////////////////////////////////////////////////////////////////////////
//

bool CDorgemEvent::Write(TiXmlElement* pElem)
{
  pElem->SetAttribute(g_strXmlName, m_strName);
  pElem->SetAttribute(g_strXmlEnabled, m_bEnabled);
  pElem->SetAttribute(g_strXmlOrder, m_iOrder);
  return(true);
}
