/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// DorgemEvent.h : header file

#ifndef __DORGEMEVENT_H__
#define __DORGEMEVENT_H__

/////////////////////////////////////////////////////////////////////////////
// The CaptionEvent and StoreEvent are derived from this class.
// The EventManager is based upon this class.

#include "../TinyXml/tinyxml.h"
#include "XmlEntries.h"

class CDorgemEvent : public wxObject
{
public:
  CDorgemEvent();

  int operator==(CDorgemEvent) const;
  int operator!=(CDorgemEvent Chk) const  { return( !(*this == Chk) ); };

  bool      IsValid();

  wxString  GetName()             { return(m_strName);              };
  bool      IsEnabled()           { return(m_bEnabled);             };
  int       GetOrder()            { return(m_iOrder);               };
  int       GetType()             { return(m_iType);                };

  void      SetName(LPCSTR sz)    { m_strName = sz;                 };
  void      SetEnabled(bool b)    { m_bEnabled = b;                 };
  void      SetOrder(int i)       { m_iOrder = i;                   };

  virtual bool Read(TiXmlElement*);
  virtual bool Write(TiXmlElement*);

protected:
  int       m_iType;              // Type is the event
  //wxString  m_strTypeName;        // The name of the type is the event
  wxString  m_strName;            // The name of the event
  bool      m_bEnabled;           // Is this event enabled
  int       m_iOrder;             // Order of the event

};

#endif // __DORGEMEVENT_H__
