/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// EventManager.h: interface for the CEventManager class.

#ifndef __EVENTMANAGER_H__
#define __EVENTMANAGER_H__

#include <wx/dynarray.h>

class CDorgemEvent;

WX_DECLARE_OBJARRAY(CDorgemEvent*, CDorgemEventArray);

class CEventManager
{
public:
  CEventManager();
  ~CEventManager();

  bool Exist(wxString);
  bool Exist(CDorgemEvent*);

  bool AddEvent(CDorgemEvent&);
  bool AddEvent(CDorgemEvent*);
  void RemoveAll();
  bool Remove(wxString);
  bool Remove(CDorgemEvent*);

  CDorgemEvent* GetFirstEvent();
  CDorgemEvent* GetNextEvent();

  void Order();

protected:
  CDorgemEventArray m_pEvent;         // The events
  size_t            m_iCount;         // Counter for GetFirst-GetNext
};

#endif // __EVENTMANAGER_H__
