/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

#include "Dorgem.h"
#include "ScrollTextDlg.h"

BEGIN_EVENT_TABLE(CScrollTextDlg, wxDialog)
END_EVENT_TABLE()

/////////////////////////////////////////////////////////////////////////////
//

CScrollTextDlg::CScrollTextDlg(wxWindow* pParent, wxSize size, wxString strText) :
  wxDialog(pParent, -1, wxT(PRODUCT_NAME), wxDefaultPosition, size, wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER)
{
  wxBoxSizer *topsizer = new wxBoxSizer(wxVERTICAL);

  // Create text ctrl with minimal size 100x60 that is horizontally and
  // vertically stretchable with a border width of 7
  topsizer->Add(
    new wxTextCtrl(this, -1, strText, wxDefaultPosition, wxSize(100, 60), wxTE_MULTILINE | wxTE_READONLY),
    wxSizerFlags(1).Align(wxEXPAND).Expand().Border(wxALL, 7));

  // Create a button that is horizontally unstretchable,
  // with an all-around border with a width of 10 and implicit top alignment
  wxBoxSizer *button_sizer = new wxBoxSizer(wxHORIZONTAL);
  button_sizer->Add(new wxButton(this, wxID_OK, _("OK")), wxSizerFlags(0).Align(wxEXPAND).Border(wxALL, 7));

  // Create a sizer with no border and centered horizontally
  topsizer->Add(button_sizer, wxSizerFlags(0).Center());

  SetSizer(topsizer);             // use the sizer for layout
  topsizer->SetSizeHints(this);   // set size hints to honour minimum size

  // Center the dialog
  CenterOnParent();
}
