/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// StoreFTP.h : header file

#ifndef __STOREFTP_H__
#define __STOREFTP_H__

#include "StoreEvent.h"

class wxFTP;

/////////////////////////////////////////////////////////////////////////////
//

class CStoreFTP : public CStoreEvent
{
public:
  CStoreFTP();
  ~CStoreFTP();

  bool Store();
  void *Entry();

  wxString  GetFile()               { return(m_strFile);        };
  wxString  GetHost()               { return(m_strHost);        };
  wxString  GetUser()               { return(m_strUser);        };
  wxString  GetPassword()           { return(m_strPassword);    };
  bool      KeepOpen()              { return(m_bKeepOpen);      };
  bool      UsePassiveFTP()         { return(m_bPassiveFTP);    };

  void SetFile(wxString s)          { m_strFile = s;            };
  void SetHost(wxString s)          { m_strHost = s;            };
  void SetUser(wxString s)          { m_strUser = s;            };
  void SetPassword(wxString s)      { m_strPassword = s;        };
  void UsePassiveFTP(bool b)        { m_bPassiveFTP = b;        };
  void KeepOpen(bool b)             { m_bKeepOpen = b;          };

  bool Read(TiXmlElement*);
  bool Write(TiXmlElement*);

protected:
  wxFTP*        m_pConnection;    // The current FTP connection
  wxString      m_strHost;        // FTP host to store the image
  wxString      m_strUser;        // Username on the FTP host
  wxString      m_strPassword;    // Password on the FTP host
  wxString      m_strFile;        // File on the FTP host
  bool          m_bKeepOpen;      // Try to keep the connection open between stores?
  bool          m_bPassiveFTP;    // Use active or passive FTP?

  bool OpenConnection();
  void CloseConnection(bool = false);
  bool MoveFileTo(wxString, wxString);

};

#endif // __STOREFTP_H__
