/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////

/*
#if defined(__GNUG__) && !defined(NO_GCC_PRAGMA)
    #pragma implementation "wxvidcap.h"
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif
*/

#include "Dorgem.h"
#include "DorgemDlg.h"
#include "VideoWindow.h"

BEGIN_EVENT_TABLE(CVideoWindow, wxVideoCaptureWindow)
  EVT_VIDEO_STATUS(ID_VIDEOWIN, CVideoWindow::OnVideoStatusEvent)
  EVT_VIDEO_FRAME(ID_VIDEOWIN, CVideoWindow::OnVideoFrameEvent)
  EVT_VIDEO_STREAM(ID_VIDEOWIN, CVideoWindow::OnVideoStreamEvent)
  EVT_VIDEO_ERROR(ID_VIDEOWIN, CVideoWindow::OnVideoErrorEvent)
  EVT_VIDEO(ID_VIDEOWIN, CVideoWindow::OnVideoEvent)
END_EVENT_TABLE()

CVideoWindow::CVideoWindow(wxWindow *parent, wxWindowID id,
                           const wxPoint &pos, const wxSize &size,
                           long style, const wxString &name) : wxVideoCaptureWindow(parent, id, pos, size, style, name)
{
  m_frame = (CDorgemDlg*) parent;//->GetParent();
}

CVideoWindow::~CVideoWindow()
{
}

void CVideoWindow::OnVideoEvent( wxVideoCaptureEvent &event )
{
    //wxString str;
    //str.Printf(wxT("EVT_VIDEO: %s \n"), event.GetStatusText().c_str());
    //m_frame->m_logTextCtrl->AppendText(str);

    event.Skip();
}

void CVideoWindow::OnVideoStatusEvent( wxVideoCaptureEvent &event )
{
    wxString str;
    str.Printf(wxT("EVT_VIDEO_STATUS: %s \n"), event.GetStatusText().c_str());
    m_frame->m_logTextCtrl->AppendText(str);

    //str.Printf(wxT("%s"), event.GetStatusText().c_str());
    //m_frame->SetStatusText(str, 1);

    event.Skip();
}

void CVideoWindow::OnVideoFrameEvent( wxVideoCaptureEvent &event )
{
  unsigned int msperframe = event.GetFramerateMS();
  if (msperframe == 0)
    msperframe = 1000;

  wxString str;
  str.Printf(wxT("EVT_VIDEO_FRAME: Frame #: %ld, ms/frame: %d, fps: %2.2f\n"),
                  event.GetFrameNumber(), msperframe, 1000.0 / msperframe);

  //m_frame->m_logTextCtrl->AppendText(str);
  //m_frame->SetStatusText(str, 1);
  event.Skip();
}

void CVideoWindow::OnVideoStreamEvent( wxVideoCaptureEvent &event )
{
    m_frame->m_logTextCtrl->AppendText(wxString::Format(wxT("StreamEvent \x0D\x0A")));
    event.Skip();
}

void CVideoWindow::OnVideoErrorEvent( wxVideoCaptureEvent &event )
{
    wxString wxstr;
    wxstr.Printf(wxT("EVT_VIDEO_ERROR: %s \n"), event.GetErrorText().c_str());

    m_frame->m_logTextCtrl->AppendText(wxstr);
    event.Skip();
}
