/////////////////////////////////////////////////////////////////////////////
//                                                                         //
//  Dorgem - Webcam Capture application                                    //
//  Copyright (C) 2001-2007 Frank Fesevur                                  //
//                                                                         //
//  This program is free software; you can redistribute it and/or modify   //
//  it under the terms of the GNU General Public License as published by   //
//  the Free Software Foundation; either version 2 of the License, or      //
//  (at your option) any later version.                                    //
//                                                                         //
//  This program is distributed in the hope that it will be useful,        //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of         //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the           //
//  GNU General Public License for more details.                           //
//                                                                         //
//  You should have received a copy of the GNU General Public License      //
//  along with this program; if not, write to the Free Software            //
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              //
//                                                                         //
/////////////////////////////////////////////////////////////////////////////
// WebServer.h : header file

#ifndef __WEBSERVER_H__
#define __WEBSERVER_H__

#include <wx/socket.h>
#include "StoreEvent.h"

class CVideoWindow;

/////////////////////////////////////////////////////////////////////////////
//

class CWebServer : public wxEvtHandler, CStoreEvent
{
public:
  CWebServer(wxWindow* pWnd, CVideoWindow* pVidWnd);
  ~CWebServer();

  bool Start();
  bool Stop();
  void SetPort(int i)        { m_iPort = i;  };

  // Place holder
  bool Store()               { return(true); };

private:
  void OnServerEvent(wxSocketEvent& event);
  void OnSocketEvent(wxSocketEvent& event);
  bool ParseRequest(const char* pBuf, size_t iSize);
  wxString GetHttpDate();

  bool SendString(wxSocketBase* pSock, wxString strMsg);
  bool SendStatus(wxSocketBase* pSock, int iStatus, wxString strMsg);
  bool SendHeader(wxSocketBase* pSock, wxString, wxString strMsg);
  bool SendHeader(wxSocketBase* pSock, wxString strName, int iValue);
  bool SendImage(wxSocketBase* pSock, wxImage* img, bool bStillImage);

  int  m_iPort;
  int  m_iConnections;
  bool m_bIsRunning;
  wxWindow*        m_pWnd;
  wxSocketServer*  m_pServer;
  CVideoWindow*    m_vidCapWin;

  DECLARE_EVENT_TABLE()

};

#endif // __WEBSERVER_H__
